// SNIPPET START: prolog
package example;

import org.bjv2.util.serviceprovider.Spi;
import uk.ac.ncl.cs.instantsoap.stringprocessor.StringProcessor;
import uk.ac.ncl.cs.instantsoap.wsapi.InvalidJobSpecificationException;
import uk.ac.ncl.cs.instantsoap.wsapi.JobExecutionException;
import uk.ac.ncl.cs.instantsoap.wsapi.MetaData;
import static uk.ac.ncl.cs.instantsoap.wsapi.Wsapi.metaData;

@Spi
public class BobAppender
        implements StringProcessor
{
// SNIPPET END: prolog

    // SNIPPET START: description
    public MetaData describeApplication()
    {
        return metaData("bobAppender",
                        "Append the string 'BOB' to the end of the input");
    }
// SNIPPET END: description

// SNIPPET START: input-output
    public MetaData getInput()
    {
        return metaData("input",
                        "The input string to process");
    }

    public MetaData getOutputs()
    {
        return metaData("output",
                        "The input string with 'BOB' appended");
    }
// SNIPPET END: input-output

// SNIPPET START: validate
    public void validate(String data)
            throws InvalidJobSpecificationException
    {
        // nothing to do
    }
// SNIPPET END: validate

// SNIPPET START: process
    public String process(String data)
            throws JobExecutionException
    {
        return data + "BOB";
    }
// SNIPPET END: process

// SNIPPET START: epilog
}
// SNIPPET END: epilog
